;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;+
; NAME:
;       ibis_i2quv_mask
;
; PURPOSE:
;
; CATEGORY:
;
; CALLING SEQUENCE:
;
;
; INPUTS:
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;
;
; OPTIONAL OUTPUTS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;
;-
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FUNCTION ibis_i2quv_mask, tmp, $ 
                          INIT_MASK = init_mask, THRESH_MASK = thresh_mask

;;***************************************************************
;; calculate total polarization
;;***************************************************************

     tpol = total(SQRT((REFORM(tmp[*,*,*,1])/REFORM(tmp[*,*,*,0]))^2. + $ 
                       (REFORM(tmp[*,*,*,2])/REFORM(tmp[*,*,*,0]))^2. + $ 
                       (REFORM(tmp[*,*,*,3])/REFORM(tmp[*,*,*,0]))^2.), 3) 

     index = WHERE( finite(tpol, /NAN) EQ 1, COMPLEMENT = index_valid)

     IF index[0] NE -1 THEN tpol[index] = AVG( tpol[index_valid] )


;;***************************************************************
;; Calculate initial mask and threshold value
;;***************************************************************

     IF KEYWORD_SET(INIT_MASK) THEN BEGIN

        ;;***************************************************************
        ;; Show input and determine mask parameters
        ;;***************************************************************

        frame = tpol
        mask = 0*FIX(frame)

        tvscl, ALOG10(frame)
        thresh_mask = MEAN(frame)
        inc = 0.01

        PRINT,'---------------------------------------------------------'
        PRINT,'type "a" or "d" to increase/decrease the threshold value '
        PRINT,'type "w" or "s" to increase/decrease the increment value '
        PRINT,'type "q" when done                                       '
        PRINT,'---------------------------------------------------------'

        k = GET_KBRD(1)

        WHILE (k NE 'q') DO BEGIN

              IF (k EQ 'd') THEN thresh_mask += inc ELSE $
              IF (k EQ 'a') THEN thresh_mask -= inc ELSE $
              IF (k EQ 'w') THEN inc += 0.01 ELSE $
              IF (k EQ 's') THEN inc -= 0.01

              mask *= 0
              mask[WHERE((frame LT thresh_mask) * (frame NE frame[5,5]))] = 1
              TVSCL, mask
              WRITEU,-1, 'Threshold: '+strtrim(thresh_mask,2), '     Increase: '+strtrim(inc,2)+string(13B)
              k = GET_KBRD(1)

        ENDWHILE

     ENDIF ELSE BEGIN

           frame = tpol
           mask = 0*FIX(frame)
           mask[WHERE((frame LT thresh_mask) * (frame NE frame[5,5]))] = 1
           
     ENDELSE 

;;***************************************************************
;; Done
;;***************************************************************

     RETURN, mask

END
