;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FUNCTION ibis_create_struct, Ntotal, NFILES = nfiles

if keyword_set(NFILES) then begin 

     tmp = create_struct('filename', strarr(Ntotal,nfiles), $
                         'extension', lonarr(Ntotal,nfiles), $ 
                         'time', dblarr(Ntotal,nfiles), $
                         'filter', lonarr(Ntotal,nfiles), $ 
                         'exptime', dblarr(Ntotal,nfiles), $ 
                         'wave', dblarr(Ntotal,nfiles), $ 
                         'grid', dblarr(Ntotal,nfiles), $ 
                         'fpi1', fltarr(Ntotal,nfiles), $ 
                         'fpi2', fltarr(Ntotal,nfiles), $ 
                         'lcvr1', fltarr(Ntotal,nfiles), $ 
                         'lcvr2', fltarr(Ntotal,nfiles), $ 
                         'stokes', strarr(Ntotal,nfiles), $
                         'frame', dblarr(Ntotal,nfiles), $ 
                         'dst_time', dblarr(Ntotal,nfiles), $ 
                         'dst_az', dblarr(Ntotal,nfiles), $ 
                         'dst_el', dblarr(Ntotal,nfiles), $ 
                         'dst_tbl', fltarr(Ntotal,nfiles), $ 
                         'dst_gdrn', dblarr(Ntotal,nfiles), $ 
                         'dst_xgdr', dblarr(Ntotal,nfiles), $ 
                         'dst_ygdr', dblarr(Ntotal,nfiles), $ 
                         'dst_slat', dblarr(Ntotal,nfiles), $ 
                         'dst_slng', dblarr(Ntotal,nfiles), $ 
                         'dst_rv', dblarr(Ntotal,nfiles), $ 
                         'dst_pee', dblarr(Ntotal,nfiles), $ 
                         'dst_bee', dblarr(Ntotal,nfiles), $ 
                         'dst_ell', dblarr(Ntotal,nfiles), $ 
                         'dst_sdim', dblarr(Ntotal,nfiles), $ 
                         'dst_llevel', dblarr(Ntotal,nfiles), $ 
                         'dst_see', dblarr(Ntotal,nfiles), $ 
                         'dst_saz', dblarr(Ntotal,nfiles), $ 
                         'dst_sel', dblarr(Ntotal,nfiles), $ 
                         'pt4_time', dblarr(Ntotal,nfiles), $ 
                         'pt4_pstg', strarr(Ntotal,nfiles), $ 
                         'pt4_pol', dblarr(Ntotal,nfiles), $ 
                         'pt4_rstg', strarr(Ntotal,nfiles), $ 
                         'pt4_ret', dblarr(Ntotal,nfiles), $ 
                         'pt4_fs', strarr(Ntotal,nfiles))
endif else begin

     tmp = create_struct('filename', strarr(Ntotal), $
                         'extension', lonarr(Ntotal), $ 
                         'time', dblarr(Ntotal), $
                         'filter', lonarr(Ntotal), $ 
                         'exptime', dblarr(Ntotal), $ 
                         'wave', dblarr(Ntotal), $ 
                         'grid', dblarr(Ntotal), $ 
                         'fpi1', fltarr(Ntotal), $ 
                         'fpi2', fltarr(Ntotal), $ 
                         'lcvr1', fltarr(Ntotal), $ 
                         'lcvr2', fltarr(Ntotal), $ 
                         'stokes', strarr(Ntotal), $
                         'frame', dblarr(Ntotal), $ 
                         'dst_time', dblarr(Ntotal), $ 
                         'dst_az', dblarr(Ntotal), $ 
                         'dst_el', dblarr(Ntotal), $ 
                         'dst_tbl', fltarr(Ntotal), $ 
                         'dst_gdrn', dblarr(Ntotal), $ 
                         'dst_xgdr', dblarr(Ntotal), $ 
                         'dst_ygdr', dblarr(Ntotal), $ 
                         'dst_slat', dblarr(Ntotal), $ 
                         'dst_slng', dblarr(Ntotal), $ 
                         'dst_rv', dblarr(Ntotal), $ 
                         'dst_pee', dblarr(Ntotal), $ 
                         'dst_bee', dblarr(Ntotal), $ 
                         'dst_ell', dblarr(Ntotal), $ 
                         'dst_sdim', dblarr(Ntotal), $ 
                         'dst_llevel', dblarr(Ntotal), $ 
                         'dst_see', dblarr(Ntotal), $ 
                         'dst_saz', dblarr(Ntotal), $ 
                         'dst_sel', dblarr(Ntotal), $ 
                         'pt4_time', dblarr(Ntotal), $ 
                         'pt4_pstg', strarr(Ntotal), $ 
                         'pt4_pol', dblarr(Ntotal), $ 
                         'pt4_rstg', strarr(Ntotal), $ 
                         'pt4_ret', dblarr(Ntotal), $ 
                         'pt4_fs', strarr(Ntotal))

endelse

RETURN, tmp
END
