;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;+
; NAME:
;       ibis_database
;
; PURPOSE:
;
; CATEGORY:
;
; CALLING SEQUENCE:
;       
;
; INPUTS:
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;
;
; OPTIONAL OUTPUTS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;           2011-Nov, Alexandra Tritschler, NSO
;-
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
PRO ibis_database, dir, date, SAVEFILE = savefile

     data_dir = file_search(dir + date + '_*/', COUNT = Ndirs)

     PRINT,'---------------------------------------'
     PRINT,'Directories found: ', Ndirs
     PRINT,'---------------------------------------'

     Nfiles = intarr(Ndirs)
     Nimages = intarr(Ndirs)
  
     FOR j = 0, Ndirs-1 DO Nfiles[j] = n_elements(file_search( data_dir[j] + '/*.fits'))
     FOR j = 0, Ndirs-1 DO Nimages[j] = read_nimages((file_search( data_dir[j] + '/*.fits'))[0])

     FOR n = 0L, Ndirs-1 DO BEGIN

         print, 'Processing directory#: ', data_dir[n]

         files = file_search( data_dir[n] + '/*.fits', COUNT = Nfiles)

         info = ibis_create_struct(Nfiles[n]*Nimages[n])

         l = 0

         FOR k = 0L, Nfiles[n]-1 DO BEGIN

             print, 'Processing file#: ', files[k]

             FITS_OPEN, files[k], num

             FOR m = 1L, Nimages[n] DO BEGIN

                 FITS_READ, num, tmp, header, EXTEN_NO = m, /HEADER_ONLY, /NO_PDU

                 info = ibis_info(header, info, files[k], m, l)
                 l = l + 1

             ENDFOR

             FITS_CLOSE, num

         ENDFOR

         tmp = (STRMID(data_dir[nstart], (STRSPLIT(data_dir[nstart], '/'))))[N_ELEMENTS(STRSPLIT(data_dir[nstart], '/'))-1]
         outfilename = savefile + '_' + tmp + '.sav'

     ENDFOR

;;***************************************************************
;; Done!
;;***************************************************************

END
